/*
    (C) 1995-97 AROS - The Amiga Research OS
    $Id: delay.c,v 1.1.1.1 2005/03/15 15:54:40 laire Exp $

    Desc:
    Lang: english
*/

#define AROS_ALMOST_COMPATIBLE /* NEWLIST */

#include <proto/dos.h>
#include <proto/exec.h>
#include <string.h>
#include "dos_intern.h"
#include <devices/timer.h>

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH1(void, Delay,

/*  SYNOPSIS */
	AROS_LHA(ULONG, timeout, D1),

/*  LOCATION */
	struct DosLibrary *, DOSBase, 33, Dos)

/*  FUNCTION
        Waits for at least the time specified as timeout.

    INPUTS
        timeout - the minimum time to wait in ticks (1/50 seconds)

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	29-10-95    digulla automatically created from
			    dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

    struct MsgPort 	timermp;
    struct timerequest  timerio;

    //This is task safe FAILFORTASKNP(return;)

    //memclr(&timermp, sizeof(timermp));
    timermp.mp_Node.ln_Type = NT_MSGPORT;
    timermp.mp_Flags 	    = PA_SIGNAL;
    timermp.mp_SigBit	    = SIGB_DOS;
    timermp.mp_SigTask	    = FindTask(NULL);
    NEWLIST(&timermp.mp_MsgList);

    timerio.tr_node.io_Message.mn_Node.ln_Type = NT_REPLYMSG;
    timerio.tr_node.io_Message.mn_ReplyPort    = &timermp;
    timerio.tr_node.io_Device                  = DOSBase->dl_TimerIO.tr_node.io_Device;
    timerio.tr_node.io_Unit                    = DOSBase->dl_TimerIO.tr_node.io_Unit;
    timerio.tr_node.io_Command 		       = TR_ADDREQUEST;
    timerio.tr_time.tv_secs                    = timeout / TICKS_PER_SECOND;
    timerio.tr_time.tv_micro  		       = 1000000UL / TICKS_PER_SECOND * (timeout % TICKS_PER_SECOND);

    DoIO(&timerio.tr_node);

    AROS_LIBFUNC_EXIT
} /* Delay */
